----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 23.12.2021 17:21:30
-- Design Name: 
-- Module Name: BaseDeTemps - a_BaseDeTemps
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity BaseDeTemps is
    Port ( H : in STD_LOGIC;
           T1us, T1ms, T10ms, T100ms, T1s, LED : out STD_LOGIC);
end BaseDeTemps;

architecture a_BaseDeTemps of BaseDeTemps is
signal T1usI, T1msI, T10msI, T1sI, T100msI, LEDI:STD_LOGIC:='0';
component DiviseurN  
generic(N:integer:=125);
port(
	H,CE:in std_logic;
	TN:out std_logic:='1'
	);
end component;

begin
LED<=LEDI;
T1us<=T1usI;
T1ms<=T1msI;
T10ms<=T10msI;
T100ms<=T100msI;
T1s<=T1sI;
div125 : DiviseurN 
    generic map(N=>125)
    port map (H=>H, CE=>'1', TN=>T1usI);
    
div1000_1 : DiviseurN 
    generic map(N=>1000)
    port map (H=>H, CE=>T1usI, TN=>T1msI);
div10_1 : DiviseurN 
    generic map(N=>10)
    port map (H=>H, CE=>T1msI, TN=>T10msI);    
div10_2 : DiviseurN 
    generic map(N=>10)
    port map (H=>H, CE=>T10msI, TN=>T100msI);
div10_3 : DiviseurN 
    generic map(N=>10)
    port map (H=>H, CE=>T100msI, TN=>T1sI);

process(H)
begin
    if H'event and H='1' and T1sI = '1' then 
        LEDI<=not LEDI;
    end if;
end process;
end a_BaseDeTemps;
