LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;
use ieee.numeric_std.all;

ENTITY vitesseCodeur IS 
generic(cptMax:integer:=20000);
PORT
	(
	A,B,H,T1us:IN std_logic;
	V:out std_logic_vector(31 downto 0)
	--V:out integer range -32767 to 32767:=0
	);
END ;
ARCHITECTURE a_vitesseCodeur OF vitesseCodeur IS
	signal cpt:integer range 0 to cptMax+1;
	signal Vcalc:std_logic_vector(31 downto 0); 
	signal A_old:std_logic:='0';
	signal etat:integer range 0 to 2:=0;
	signal cptStab:integer range 0 to 500:=0;
BEGIN
	PROCESS (H)
	BEGIN
		if (H'event and H='1' and T1us = '1') then
			if (A_old='0' and A='1')then -- Front montant sur A
				
				if cpt/=0 and cpt/=cptMax+1 then
					if B='0' then
						Vcalc<=std_logic_vector(to_signed(200000/cpt,32));
						--Vcalc<=std_logic_vector(to_signed(cpt,32));
					else
						Vcalc<=std_logic_vector(to_signed(-200000/cpt,32));
						--Vcalc<=std_logic_vector(to_signed(-cpt,32));
					end if;					
				end if;
                etat<= 1; -- Stabilisation
                --cptStab<=0; -- reset tempo Stab
                cpt<=0;

			else --if T1us = '1' then -- Pas de front montant de A
				if cpt<cptMax then
					cpt<=cpt+1;
				elsif cpt=cptMax then
				    Vcalc<=std_logic_vector(to_signed(0,32));
				    etat<= 1; -- Stabilisation
		            --cptStab<=0; -- reset tempo Stab	
		            cpt<=cpt+1;
				end if;	
				--V<=Vcalc(31)&Vcalc(14 downto 0);			
			end if;
		A_old<=A;
		case(etat)is
            when 0=>-- Attente
            when 1=> etat<=2;
                --if(cptStab<200) then cptStab<=cptStab+1;
                --elsif(T1us = '1')then etat<=2;
                --end if;
            when 2=>
                V<=Vcalc;
                etat<=0;
                --cptStab<=0; -- reset tempo Stab
            when others=> etat<=0;
		end case;
		end if;
	END PROCESS;
	--V<=std_logic_vector(to_unsigned(cptStab,16));
END;

